## guvcview-2.2.1-2.src.tar.gz

=== guvcview/CMakeLists.txt ===
set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(USE_GTK3 "Enable Gtk3 gui" ON)
option(USE_QT6  "Enable Qt6 gui" OFF)

add_compile_definitions(GETTEXT_PACKAGE="guvcview")
add_compile_definitions(PACKAGE_DATA_DIR="${CMAKE_INSTALL_DATADIR}")
add_compile_definitions(VERSION="${CMAKE_PROJECT_VERSION}")

add_executable(guvcview
  config.c
  core_io.c
  gui.c
  guvcview.c
  options.c
  video_capture.c
)

if(USE_GTK3)
  pkg_check_modules(GTK3 gtk+-3.0)
  if(GTK3_FOUND)
    message(STATUS "Gtk3 is ON")
    add_compile_definitions(ENABLE_GTK3)
    target_link_libraries(guvcview ${GTK3_LIBRARIES})
    add_definitions(${GTK3_CFLAGS} ${GTK3_CFLAGS_OTHER})
    target_sources(guvcview PRIVATE
      gui_gtk3_audioctrls.c
      gui_gtk3.c
      gui_gtk3_callbacks.c
      gui_gtk3_h264ctrls.c
      gui_gtk3_menu.c
      gui_gtk3_v4l2ctrls.c
      gui_gtk3_videoctrls.c)
  endif()
endif()

if(USE_QT6)
  pkg_check_modules(QT6 Qt6Core Qt6Widgets Qt6Gui)
  if(QT6_FOUND)
    find_package(Qt6 REQUIRED COMPONENTS Widgets)
    message(STATUS "Qt6 is ON")
    qt_standard_project_setup()

    qt_add_library(guvcviewqt STATIC
      gui_qt6_audioctrls.cpp
      gui_qt6_callbacks.cpp
      gui_qt6.cpp
      gui_qt6_h264ctrls.cpp
      gui_qt6_menu.cpp
      gui_qt6_v4l2ctrls.cpp
      gui_qt6_videoctrls.cpp)

    add_compile_definitions(ENABLE_QT6)
    target_link_libraries(guvcviewqt PRIVATE Qt6::Widgets)
    add_definitions(${QT6_CFLAGS} ${QT6_CFLAGS_OTHER})

    target_link_libraries(guvcview guvcviewqt)
  endif()
endif()

if(GL_FOUND)
  message(STATUS "linking guvcview to ${GL_LIBRARIES}")
  target_link_libraries(guvcview ${GL_LIBRARIES})
endif()

include_directories(
  ${CMAKE_SOURCE_DIR}/includes
  ${CMAKE_SOURCE_DIR}/gview_audio
  ${CMAKE_SOURCE_DIR}/gview_encoder
  ${CMAKE_SOURCE_DIR}/gview_render
  ${CMAKE_SOURCE_DIR}/gview_v4l2core)

target_link_libraries(guvcview
  gviewaudio
  gviewencoder
  gviewrender
  gviewv4l2core)

install(TARGETS guvcview)

=== PKGBUILD ===
# Maintainer: Balló György <ballogyor+arch at gmail dot com>
# Contributor: Giovanni Scafora <giovanni@archlinux.org>
# Contributor: Maxwell Pray a.k.a. Synthead <synthead@gmail.com>

pkgbase=guvcview
pkgname=(guvcview guvcview-common guvcview-qt)
pkgver=2.2.1
pkgrel=2
pkgdesc='Simple interface for capturing and viewing video from v4l2 devices'
arch=('x86_64')
url='http://guvcview.sourceforge.net/'
license=('GPL3')
depends=('ffmpeg' 'gsl' 'gtk3' 'qt6-base' 'portaudio')
makedepends=('cmake')
options=('!emptydirs')
source=("https://downloads.sourceforge.net/$pkgbase/$pkgbase-src-$pkgver.tar.bz2")
sha256sums=('d2adc7ce762961e853c3e16b511bad61504492d12f3e2eb7e30da4a2f7ade5af')
noextract=($pkgbase-src-$pkgver-2.tar.bz2) # missing root dir

prepare() {
  # Fix appdata install dir
  sed -e 's|\/appdata|\/metainfo|' -i $pkgbase-src-$pkgver/data/CMakeLists.txt
  # Build fix for ffmpeg 8
  sed -i 's#FF_PROFILE#AV_PROFILE#g' "$pkgbase-src-$pkgver"/gview_encoder/audio_codecs.c
}

build() {
  # GTK+ version
  cmake -B build-gtk -S $pkgbase-src-$pkgver \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DUSE_SFML=ON
  cmake --build build-gtk

  # Qt version
  cmake -B build-qt -S $pkgbase-src-$pkgver \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DUSE_SFML=ON \
    -DUSE_QT6=ON \
    -DUSE_GTK3=OFF
  cmake --build build-qt
}

package_guvcview-common() {
  pkgdesc="Common files for guvcview"
  depends=('ffmpeg' 'gsl' 'libusb' 'portaudio')

  DESTDIR="$pkgdir" cmake --install build-gtk
  rm -r "$pkgdir"/usr/{bin,share/{man,metainfo,applications}}
  install -Dm644 $pkgbase-src-$pkgver/data/icons/guvcview.png "$pkgdir"/usr/share/icons/hicolor/128x128/apps/guvcview.png
}

package_guvcview() {
  pkgdesc="Simple GTK+ interface for capturing and viewing video from v4l2 devices"
  depends=('guvcview-common' 'gtk3')

  DESTDIR="$pkgdir" cmake --install build-gtk
  rm -r "$pkgdir"/usr/{lib,share/{pixmaps,locale}}
  sed -i 's/^Icon=.*/Icon=guvcview/' "$pkgdir"/usr/share/applications/guvcview.desktop
}

package_guvcview-qt() {
  pkgdesc="Simple Qt interface for capturing and viewing video from v4l2 devices"
  depends=('guvcview-common' 'qt6-base')

  DESTDIR="$pkgdir" cmake --install build-qt
  rm -r "$pkgdir"/usr/{lib,share/{pixmaps,locale}}
  mv "$pkgdir"/usr/bin/guvcview{,-qt}
  mv "$pkgdir"/usr/share/man/man1/guvcview{,-qt}.1.gz
  mv "$pkgdir"/usr/share/applications/guvcview{,-qt}.desktop
  sed -i 's/Exec=guvcview/Exec=guvcview-qt/
          s/^Icon=.*/Icon=guvcview/' "$pkgdir"/usr/share/applications/guvcview-qt.desktop
  mv "$pkgdir"/usr/share/metainfo/guvcview{,-qt}.appdata.xml
  sed -i 's/net.sourceforge.guvcview/net.sourceforge.guvcview-qt/
          s/guvcview.desktop/guvcview-qt.desktop/' "$pkgdir"/usr/share/metainfo/guvcview-qt.appdata.xml
}
